diff --git a/src/mongo/db/pipeline/document_source_limit.h b/src/mongo/db/pipeline/document_source/document_source_limit.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_limit.h
rename to src/mongo/db/pipeline/document_source/document_source_limit.h
index 6fe5370b0c..5610c31f4b 100644
--- a/src/mongo/db/pipeline/document_source_limit.h
+++ b/src/mongo/db/pipeline/document_source/document_source_limit.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_limit_test.cpp b/src/mongo/db/pipeline/document_source/document_source_limit_test.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source_limit_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_limit_test.cpp
index 04aa426bd1..ac228b5d1a 100644
--- a/src/mongo/db/pipeline/document_source_limit_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_limit_test.cpp
@@ -34,9 +34,9 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_list_cached_and_active_users.cpp b/src/mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_list_cached_and_active_users.cpp
rename to src/mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.cpp
index 535d4ebb1e..f0ff3b2509 100644
--- a/src/mongo/db/pipeline/document_source_list_cached_and_active_users.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_list_cached_and_active_users.h"
+#include "mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.h"
 
 #include "mongo/db/auth/authorization_session.h"
 #include "mongo/db/auth/user_name.h"
diff --git a/src/mongo/db/pipeline/document_source_list_cached_and_active_users.h b/src/mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_list_cached_and_active_users.h
rename to src/mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.h
index f1f1e25e55..e8f83b080e 100644
--- a/src/mongo/db/pipeline/document_source_list_cached_and_active_users.h
+++ b/src/mongo/db/pipeline/document_source/document_source_list_cached_and_active_users.h
@@ -32,7 +32,7 @@
 #include "mongo/bson/bsonmisc.h"
 #include "mongo/bson/bsonobj.h"
 #include "mongo/db/auth/authorization_manager.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_list_local_sessions.cpp b/src/mongo/db/pipeline/document_source/document_source_list_local_sessions.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_list_local_sessions.cpp
rename to src/mongo/db/pipeline/document_source/document_source_list_local_sessions.cpp
index f9c329ff65..f9d78bb1af 100644
--- a/src/mongo/db/pipeline/document_source_list_local_sessions.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_list_local_sessions.cpp
@@ -32,8 +32,8 @@
 #include "mongo/db/auth/authorization_session.h"
 #include "mongo/db/auth/user_name.h"
 #include "mongo/db/logical_session_id_helpers.h"
-#include "mongo/db/pipeline/document_source_list_local_sessions.h"
-#include "mongo/db/pipeline/document_source_list_sessions_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_list_local_sessions.h"
+#include "mongo/db/pipeline/document_source/document_source_list_sessions_gen.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_list_local_sessions.h b/src/mongo/db/pipeline/document_source/document_source_list_local_sessions.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_list_local_sessions.h
rename to src/mongo/db/pipeline/document_source/document_source_list_local_sessions.h
index 5306fc1fb7..38f36bf4da 100644
--- a/src/mongo/db/pipeline/document_source_list_local_sessions.h
+++ b/src/mongo/db/pipeline/document_source/document_source_list_local_sessions.h
@@ -35,8 +35,8 @@
 #include "mongo/bson/bsonobj.h"
 #include "mongo/crypto/sha256_block.h"
 #include "mongo/db/logical_session_cache.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_list_sessions_gen.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_list_sessions_gen.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_list_sessions.cpp b/src/mongo/db/pipeline/document_source/document_source_list_sessions.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source_list_sessions.cpp
rename to src/mongo/db/pipeline/document_source/document_source_list_sessions.cpp
index 996856b365..0178aaefe0 100644
--- a/src/mongo/db/pipeline/document_source_list_sessions.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_list_sessions.cpp
@@ -33,8 +33,8 @@
 #include "mongo/db/logical_session_id_helpers.h"
 #include "mongo/db/matcher/expression_parser.h"
 #include "mongo/db/matcher/extensions_callback_noop.h"
-#include "mongo/db/pipeline/document_source_list_sessions.h"
-#include "mongo/db/pipeline/document_source_list_sessions_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_list_sessions.h"
+#include "mongo/db/pipeline/document_source/document_source_list_sessions_gen.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_list_sessions.h b/src/mongo/db/pipeline/document_source/document_source_list_sessions.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_list_sessions.h
rename to src/mongo/db/pipeline/document_source/document_source_list_sessions.h
index 1283c6a0fa..de51de0935 100644
--- a/src/mongo/db/pipeline/document_source_list_sessions.h
+++ b/src/mongo/db/pipeline/document_source/document_source_list_sessions.h
@@ -32,8 +32,8 @@
 #include <type_traits>
 
 #include "mongo/bson/bsonelement.h"
-#include "mongo/db/pipeline/document_source_list_local_sessions.h"
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_list_local_sessions.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/util/intrusive_counter.h"
 
diff --git a/src/mongo/db/pipeline/document_source_lookup.cpp b/src/mongo/db/pipeline/document_source/document_source_lookup.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_lookup.cpp
rename to src/mongo/db/pipeline/document_source/document_source_lookup.cpp
index aade4c22aa..5532c2c0ca 100644
--- a/src/mongo/db/pipeline/document_source_lookup.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_lookup.cpp
@@ -30,7 +30,7 @@
 #include "mongo/db/commands/feature_compatibility_version_parser.h"
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_lookup.h"
 
 #include <memory>
 
@@ -41,9 +41,9 @@
 #include "mongo/db/matcher/expression_algo.h"
 #include "mongo/db/pipeline/aggregation_request_helper.h"
 #include "mongo/db/pipeline/document_path_support.h"
-#include "mongo/db/pipeline/document_source_merge_gen.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_merge_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/variable_validation.h"
 #include "mongo/db/query/collation/collator_factory_interface.h"
diff --git a/src/mongo/db/pipeline/document_source_lookup.h b/src/mongo/db/pipeline/document_source/document_source_lookup.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_lookup.h
rename to src/mongo/db/pipeline/document_source/document_source_lookup.h
index 75a2fc42a4..493f358bf2 100644
--- a/src/mongo/db/pipeline/document_source_lookup.h
+++ b/src/mongo/db/pipeline/document_source/document_source_lookup.h
@@ -32,11 +32,11 @@
 #include <boost/optional.hpp>
 
 #include "mongo/db/exec/document_value/value_comparator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_sequential_document_cache.h"
-#include "mongo/db/pipeline/document_source_unwind.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_sequential_document_cache.h"
+#include "mongo/db/pipeline/document_source/document_source_unwind.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lite_parsed_pipeline.h"
 #include "mongo/db/pipeline/lookup_set_cache.h"
 
diff --git a/src/mongo/db/pipeline/document_source_lookup_test.cpp b/src/mongo/db/pipeline/document_source/document_source_lookup_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_lookup_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_lookup_test.cpp
index f094518c66..daba7ac6c7 100644
--- a/src/mongo/db/pipeline/document_source_lookup_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_lookup_test.cpp
@@ -42,8 +42,8 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_lookup.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/pipeline/process_interface/stub_mongo_process_interface.h"
 #include "mongo/db/query/query_knobs_gen.h"
diff --git a/src/mongo/db/pipeline/document_source_match.cpp b/src/mongo/db/pipeline/document_source/document_source_match.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_match.cpp
rename to src/mongo/db/pipeline/document_source/document_source_match.cpp
index 6686626438..4e7063512b 100644
--- a/src/mongo/db/pipeline/document_source_match.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_match.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 
 #include <algorithm>
 #include <memory>
@@ -42,7 +42,7 @@
 #include "mongo/db/matcher/expression_parser.h"
 #include "mongo/db/matcher/extensions_callback_noop.h"
 #include "mongo/db/pipeline/document_path_support.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/util/ctype.h"
 #include "mongo/util/str.h"
diff --git a/src/mongo/db/pipeline/document_source_match.h b/src/mongo/db/pipeline/document_source/document_source_match.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_match.h
rename to src/mongo/db/pipeline/document_source/document_source_match.h
index 327820105b..0aac79439c 100644
--- a/src/mongo/db/pipeline/document_source_match.h
+++ b/src/mongo/db/pipeline/document_source/document_source_match.h
@@ -36,7 +36,7 @@
 #include "mongo/client/connpool.h"
 #include "mongo/db/matcher/expression_algo.h"
 #include "mongo/db/matcher/matcher.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/util/intrusive_counter.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_match_test.cpp b/src/mongo/db/pipeline/document_source/document_source_match_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_match_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_match_test.cpp
index 703512557d..adc1184ba2 100644
--- a/src/mongo/db/pipeline/document_source_match_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_match_test.cpp
@@ -39,8 +39,8 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/logv2/log.h"
 #include "mongo/unittest/death_test.h"
diff --git a/src/mongo/db/pipeline/document_source_merge.cpp b/src/mongo/db/pipeline/document_source/document_source_merge.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_merge.cpp
rename to src/mongo/db/pipeline/document_source/document_source_merge.cpp
index 36f652c66c..729b855b65 100644
--- a/src/mongo/db/pipeline/document_source_merge.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_merge.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_merge.h"
+#include "mongo/db/pipeline/document_source/document_source_merge.h"
 
 #include <fmt/format.h>
 #include <fmt/ostream.h>
diff --git a/src/mongo/db/pipeline/document_source_merge.h b/src/mongo/db/pipeline/document_source/document_source_merge.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_merge.h
rename to src/mongo/db/pipeline/document_source/document_source_merge.h
index 54e9620793..ba937596d9 100644
--- a/src/mongo/db/pipeline/document_source_merge.h
+++ b/src/mongo/db/pipeline/document_source/document_source_merge.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_merge_gen.h"
-#include "mongo/db/pipeline/document_source_writer.h"
+#include "mongo/db/pipeline/document_source/document_source_merge_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_writer.h"
 #include "mongo/db/pipeline/lite_parsed_pipeline.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_merge.idl b/src/mongo/db/pipeline/document_source/document_source_merge.idl
similarity index 97%
rename from src/mongo/db/pipeline/document_source_merge.idl
rename to src/mongo/db/pipeline/document_source/document_source_merge.idl
index 4def6572dd..b981324898 100644
--- a/src/mongo/db/pipeline/document_source_merge.idl
+++ b/src/mongo/db/pipeline/document_source/document_source_merge.idl
@@ -32,10 +32,10 @@ global:
     cpp_namespace: "mongo"
     cpp_includes:
         - "mongo/db/namespace_string.h"
-        - "mongo/db/pipeline/document_source_merge_spec.h"
+        - "mongo/db/pipeline/document_source/document_source_merge_spec.h"
 
 imports:
-    - "mongo/db/pipeline/document_source_merge_modes.idl"
+    - "mongo/db/pipeline/document_source/document_source_merge_modes.idl"
     - "mongo/idl/basic_types.idl"
     - "mongo/s/chunk_version.idl"
 
diff --git a/src/mongo/db/pipeline/document_source_merge_cursors_test.cpp b/src/mongo/db/pipeline/document_source/document_source_merge_cursors_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_merge_cursors_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_merge_cursors_test.cpp
index 61b2aef0c9..2a01c7363c 100644
--- a/src/mongo/db/pipeline/document_source_merge_cursors_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_merge_cursors_test.cpp
@@ -39,8 +39,8 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/json.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/query/cursor_response.h"
 #include "mongo/db/query/getmore_command_gen.h"
diff --git a/src/mongo/db/pipeline/document_source_merge_spec.cpp b/src/mongo/db/pipeline/document_source/document_source_merge_spec.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source_merge_spec.cpp
rename to src/mongo/db/pipeline/document_source/document_source_merge_spec.cpp
index 2ca9a21edf..5c754bf5e3 100644
--- a/src/mongo/db/pipeline/document_source_merge_spec.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_merge_spec.cpp
@@ -29,14 +29,14 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_merge_spec.h"
+#include "mongo/db/pipeline/document_source/document_source_merge_spec.h"
 
 #include <fmt/format.h>
 
 #include "mongo/bson/bsonobjbuilder.h"
 #include "mongo/db/pipeline/aggregation_request_helper.h"
-#include "mongo/db/pipeline/document_source_merge.h"
-#include "mongo/db/pipeline/document_source_merge_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_merge.h"
+#include "mongo/db/pipeline/document_source/document_source_merge_gen.h"
 
 namespace mongo {
 using namespace fmt::literals;
diff --git a/src/mongo/db/pipeline/document_source_merge_spec.h b/src/mongo/db/pipeline/document_source/document_source_merge_spec.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_merge_spec.h
rename to src/mongo/db/pipeline/document_source/document_source_merge_spec.h
index 35c353bb78..bda537af3b 100644
--- a/src/mongo/db/pipeline/document_source_merge_spec.h
+++ b/src/mongo/db/pipeline/document_source/document_source_merge_spec.h
@@ -35,7 +35,7 @@
 
 #include "mongo/base/string_data.h"
 #include "mongo/db/namespace_string.h"
-#include "mongo/db/pipeline/document_source_merge_modes_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_merge_modes_gen.h"
 
 namespace mongo {
 class BSONObjBuilder;
diff --git a/src/mongo/db/pipeline/document_source_merge_test.cpp b/src/mongo/db/pipeline/document_source/document_source_merge_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_merge_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_merge_test.cpp
index d58db582df..aa1a606ba3 100644
--- a/src/mongo/db/pipeline/document_source_merge_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_merge_test.cpp
@@ -34,7 +34,7 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_merge.h"
+#include "mongo/db/pipeline/document_source/document_source_merge.h"
 #include "mongo/db/pipeline/process_interface/non_shardsvr_process_interface.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_mock.cpp b/src/mongo/db/pipeline/document_source/document_source_mock.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_mock.cpp
rename to src/mongo/db/pipeline/document_source/document_source_mock.cpp
index 4567f5e217..7abf4be1cf 100644
--- a/src/mongo/db/pipeline/document_source_mock.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_mock.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/pipeline/expression_context.h"
diff --git a/src/mongo/db/pipeline/document_source_mock.h b/src/mongo/db/pipeline/document_source/document_source_mock.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_mock.h
rename to src/mongo/db/pipeline/document_source/document_source_mock.h
index 846f274753..fca0ba568d 100644
--- a/src/mongo/db/pipeline/document_source_mock.h
+++ b/src/mongo/db/pipeline/document_source/document_source_mock.h
@@ -31,7 +31,7 @@
 
 #include <deque>
 
-#include "mongo/db/pipeline/document_source_queue.h"
+#include "mongo/db/pipeline/document_source/document_source_queue.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/pipeline/stage_constraints.h"
 
diff --git a/src/mongo/db/pipeline/document_source_mock_test.cpp b/src/mongo/db/pipeline/document_source/document_source_mock_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_mock_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_mock_test.cpp
index 374c860173..90b3165f68 100644
--- a/src/mongo/db/pipeline/document_source_mock_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_mock_test.cpp
@@ -32,7 +32,7 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_operation_metrics.cpp b/src/mongo/db/pipeline/document_source/document_source_operation_metrics.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_operation_metrics.cpp
rename to src/mongo/db/pipeline/document_source/document_source_operation_metrics.cpp
index 548a7b3679..59b06dbaef 100644
--- a/src/mongo/db/pipeline/document_source_operation_metrics.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_operation_metrics.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_operation_metrics.h"
+#include "mongo/db/pipeline/document_source/document_source_operation_metrics.h"
 
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/server_options.h"
diff --git a/src/mongo/db/pipeline/document_source_operation_metrics.h b/src/mongo/db/pipeline/document_source/document_source_operation_metrics.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_operation_metrics.h
rename to src/mongo/db/pipeline/document_source/document_source_operation_metrics.h
index d4e25d47bc..11d2921a47 100644
--- a/src/mongo/db/pipeline/document_source_operation_metrics.h
+++ b/src/mongo/db/pipeline/document_source/document_source_operation_metrics.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_out.cpp b/src/mongo/db/pipeline/document_source/document_source_out.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_out.cpp
rename to src/mongo/db/pipeline/document_source/document_source_out.cpp
index 1fef7bb2bd..f6891e00ab 100644
--- a/src/mongo/db/pipeline/document_source_out.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_out.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_out.h"
+#include "mongo/db/pipeline/document_source/document_source_out.h"
 
 #include <fmt/format.h>
 
diff --git a/src/mongo/db/pipeline/document_source_out.h b/src/mongo/db/pipeline/document_source/document_source_out.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_out.h
rename to src/mongo/db/pipeline/document_source/document_source_out.h
index 140544897d..09f4efb8c5 100644
--- a/src/mongo/db/pipeline/document_source_out.h
+++ b/src/mongo/db/pipeline/document_source/document_source_out.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_writer.h"
+#include "mongo/db/pipeline/document_source/document_source_writer.h"
 
 namespace mongo {
 /**
diff --git a/src/mongo/db/pipeline/document_source_out_test.cpp b/src/mongo/db/pipeline/document_source/document_source_out_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_out_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_out_test.cpp
index aef9be321f..15e0283b0b 100644
--- a/src/mongo/db/pipeline/document_source_out_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_out_test.cpp
@@ -34,7 +34,7 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_out.h"
+#include "mongo/db/pipeline/document_source/document_source_out.h"
 
 namespace mongo {
 namespace {
diff --git a/src/mongo/db/pipeline/document_source_parsing_validators.cpp b/src/mongo/db/pipeline/document_source/document_source_parsing_validators.cpp
similarity index 95%
rename from src/mongo/db/pipeline/document_source_parsing_validators.cpp
rename to src/mongo/db/pipeline/document_source/document_source_parsing_validators.cpp
index 991575c244..a575cb66e9 100644
--- a/src/mongo/db/pipeline/document_source_parsing_validators.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_parsing_validators.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_parsing_validators.h"
+#include "mongo/db/pipeline/document_source/document_source_parsing_validators.h"
 #include "mongo/util/str.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_plan_cache_stats.cpp b/src/mongo/db/pipeline/document_source/document_source_plan_cache_stats.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_plan_cache_stats.cpp
rename to src/mongo/db/pipeline/document_source/document_source_plan_cache_stats.cpp
index bfbe60b4ec..7d6df2d008 100644
--- a/src/mongo/db/pipeline/document_source_plan_cache_stats.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_plan_cache_stats.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_plan_cache_stats.h"
+#include "mongo/db/pipeline/document_source/document_source_plan_cache_stats.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_plan_cache_stats.h b/src/mongo/db/pipeline/document_source/document_source_plan_cache_stats.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_plan_cache_stats.h
rename to src/mongo/db/pipeline/document_source/document_source_plan_cache_stats.h
index d72b0a22ac..d7e2dc2493 100644
--- a/src/mongo/db/pipeline/document_source_plan_cache_stats.h
+++ b/src/mongo/db/pipeline/document_source/document_source_plan_cache_stats.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_plan_cache_stats_test.cpp b/src/mongo/db/pipeline/document_source/document_source_plan_cache_stats_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_plan_cache_stats_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_plan_cache_stats_test.cpp
index 4f89e47acd..2771bba0de 100644
--- a/src/mongo/db/pipeline/document_source_plan_cache_stats_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_plan_cache_stats_test.cpp
@@ -33,7 +33,7 @@
 
 #include "mongo/bson/json.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_plan_cache_stats.h"
+#include "mongo/db/pipeline/document_source/document_source_plan_cache_stats.h"
 #include "mongo/db/pipeline/process_interface/stub_mongo_process_interface.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_project.cpp b/src/mongo/db/pipeline/document_source/document_source_project.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_project.cpp
rename to src/mongo/db/pipeline/document_source/document_source_project.cpp
index 3630cae344..d9f337b6b3 100644
--- a/src/mongo/db/pipeline/document_source_project.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_project.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
 
 #include <boost/optional.hpp>
 #include <boost/smart_ptr/intrusive_ptr.hpp>
diff --git a/src/mongo/db/pipeline/document_source_project.h b/src/mongo/db/pipeline/document_source/document_source_project.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_project.h
rename to src/mongo/db/pipeline/document_source/document_source_project.h
index 9401231a56..3c5af002b4 100644
--- a/src/mongo/db/pipeline/document_source_project.h
+++ b/src/mongo/db/pipeline/document_source/document_source_project.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
 #include "mongo/db/query/projection_parser.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_project_test.cpp b/src/mongo/db/pipeline/document_source/document_source_project_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_project_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_project_test.cpp
index ced99ce020..7dc29e3aea 100644
--- a/src/mongo/db/pipeline/document_source_project_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_project_test.cpp
@@ -40,8 +40,8 @@
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
 #include "mongo/db/pipeline/semantic_analysis.h"
 #include "mongo/unittest/unittest.h"
 
